import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
//linear interpolation
public class CSoundTable extends JPanel implements ActionListener {
	Grapher graph = new Grapher();
	JButton zeroButton = new JButton("ZERO");
	JButton resetButton = new JButton("RE/SET");
	JTextField instrField = new JTextField();
	JTextField startField = new JTextField();
	JTextField endField = new JTextField();
	JTextField minField = new JTextField();
	JTextField maxField = new JTextField();
	JTextField tableNo  = new JTextField();
	public void setTable(int i) {
		tableNo.setText(i+"");
	}
	public CSoundTable() {
		zeroButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				graph.zeroData();
				graph.repaint();
			}
		});
		resetButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					double min = Double.parseDouble(minField.getText());
					double max = Double.parseDouble(maxField.getText());
					int start = Integer.parseInt(startField.getText());
					int end   = Integer.parseInt(endField.getText());
					graph.changeDataSize(min,max,start,end);
				} catch (NumberFormatException nfe) {
					Error err = new Error("Please use numerical values only!");
					err.go();
				}
			}
		});
		minField.setText(graph.getMin()+"");
		maxField.setText(graph.getMax()+"");
		endField.setText(graph.getEnd()+"");
		startField.setText(graph.getStart()+"");
		instrField.setText("6666");
		tableNo.setText("1");
		setLayout(new BorderLayout());
		add(graph,BorderLayout.CENTER);
		JPanel controlPanel = new JPanel(new GridLayout(4,2));
		controlPanel.add(instrField);
		controlPanel.add(tableNo);
		controlPanel.add(minField);
		controlPanel.add(maxField);
		controlPanel.add(startField);
		controlPanel.add(endField);
		controlPanel.add(zeroButton);
		controlPanel.add(resetButton);
		add(controlPanel,BorderLayout.EAST);
		new Timer(100, this).start();
	}
	public static void main(String [] arg) {
		JFrame mainFrame = new JFrame("Grapher");
		JPanel p = new JPanel(new GridLayout(4,1));
		for (int i = 0 ; i < 4; i++ ) {
			CSoundTable g = new CSoundTable();
			g.setTable(i+1);
			g.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
			p.add(g);
		}
                mainFrame.getContentPane().add(p);
                java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize(); 
		screenSize.setSize((int)(screenSize.getWidth()*.7),(int)(screenSize.getHeight()*.7));
                mainFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
                mainFrame.setSize(screenSize);
                mainFrame.setVisible(true);
	}
	double [] data;
	public void actionPerformed(ActionEvent e) {
		//int iMax = 100;
		int iMax = 1;
		if (!graph.changed()) {
			return;	
		}
		if (data == null || data.length != graph.getDataSize()) {
			data = new double[graph.getDataSize()];
			graph.loadData(data);
			printCSound(data,0,data.length-1,iMax);
		} else {
			int index = 0;
			int changes = 0;
			double [] da = graph.dataArray();
			while (index < data.length) {
				if (data[index]!=da[index]) {
					printCSound(da,index,index+iMax,iMax);
					changes++;
					index+=iMax;
				} else {
					index++;
				}
			}
			if (changes > 0) {
				graph.loadData(data);
			}

		}
	}
	public void printCSound(double [] data,int index, int max, int count) {
		String base ="i"+instrField.getText()+" 0 0.001 " + tableNo.getText();
		int cindex = index;
		int cc = 0;
		StringBuffer buff = new StringBuffer(base+" "+cindex);
		while (cindex <= max) {
			if (cc == 0) {
				buff = new StringBuffer(base + " " + cindex);
			}
			if (cindex >= data.length) {
				buff.append(" " + 0);
			} else {
				buff.append(" "+data[cindex]);
			}
			cindex++;
			if (cc == count) {
				System.out.println(buff);
				cc = 0;
			} else {
				cc++;
			}
		}
	}

}
